# WordPress Leads #

**Contributors:** David Wells, Hudson Atwell  
**Donate link:** mailto:marketplace@inboundnow.com  
**License:** GPLv2 or later  
**License URI:** http://www.gnu.org/licenses/gpl-2.0.html  
**Tags:** leads, lead capture, lead tracking, lead collection, lead management, crm, crm tools,customer relationship management, contact management, landing page leads, extendable  
**Requires at least:** 3.8  
**Tested up to:** 4.1  
**Stable Tag:** 1.5.9  

Track visitor activity, capture and manage incoming leads, and send collected emails to your email service provider.

## Description ##

>WordPress Leads works as a standalone plugin or hand in hand with [WordPress Landing Pages](http://wordpress.org/plugins/landing-pages/ "Learn more about WordPress Landing Pages") & [WordPress Calls to Action](http://wordpress.org/plugins/cta/ "Learn more about Calls to Action") to create a powerful & free lead generation system for your business.

Wordpress leads gives you powerful visitor tracking where Google Analytics leaves off ( aka tie website activity directly to a specific individual) It allows you to track every activity that a visitor takes on your site, before converting on a web form.

### Gather Valuable Intelligence on your Leads: ###

* Learn where your leads are coming from geographically
* What pages they viewed on your site
* See past comments they have made on your blog
* Know what they have searched for on your site
* Learn where referral traffic is coming from
* See social media profiles and sites they own
* Gather demographic data
* See past/current job histories
* Learn their topical interests
* and much more.

This powerful lead data can help you sell smarter and more efficiently.

Wordpress Leads was originally built as an add-on for [WordPress Landing Pages](http://wordpress.org/plugins/landing-pages/ "Learn more about WordPress Landing Pages") but quickly grew into its own stand alone plugin to capture lead information on any page of your site.

Manage your leads directly from the admin interface, or send the lead data into a third party CRM of your choosing.

This plugin is built to be fully extendable by providing custom action and filter hooks, allowing for an almost endless number of powerful CRM application addons.

[Start Collecting Advanced Lead Intelligence in WordPress ](http://www.inboundnow.com/collecting-advanced-lead-intelligence-wordpress-free/ "Start Collecting Advanced Lead Intelligence in WordPress")


Wordpress Leads is Wordpress's first fully extendable CRM plugin.

### Highlights ###

* Built in visual form builder that is dead simple to use.
* Automatically detect and collect visitor data from any submitted form.
* Track and see what pages your leads visited before converting on your site to gain valuable lead intelligence
* Integrates seamlessly with WordPress Landing Pages and WordPress Calls to Action Plugins
* Easily search, view, and modify lead (contact) information with bulk lead management tool
* Uses geolocation services to detect additional information on first time conversion.
* Sync your leads with a third party CRM like salesforce.com, Zoho or sugarCRM.
* [Connect with Zapier to send leads to over 300+ different CRM and Email marketing tools ](http://www.inboundnow.com/zapier/  "Connect with Zapier to send leads to over 300+ different CRM and Email marketing tools")
* Developers: Extend Leads with custom functionality via built in api
* Integrate with 39+ Email service providers for Email Autoresponder Campaigns
* Integrate with 36+ CRM providers for easy lead management

### About the Plugin ###

This is a free plugin that was built to help people collect, store, and manage lead/contact information to better understand each lead that comes into their site. It's built with inbound marketing best practices in mind and integrates seamlessly with the free WordPress Landing Pages plugin.

### Developers & Designers ###

We built Lead Management as a framework! You can use our extendable framework to bring custom solutions to your application.

[Follow Development on GitHub ](https://github.com/inboundnow/leads "Follow & Contribute to core development on GitHub")
 |
[Follow Development on Twitter ](https://twitter.com/gitleads "See our latest development commits on Twitter")

## Installation ##

1. Upload `leads` folder to the `/wp-content/plugins/` directory
1. Activate the plugin through the 'Plugins' menu in WordPress

## Frequently Asked Questions ##

## Screenshots ##

### 1. Lead Management Custom Post Type ###
![Lead Management Custom Post Type](screenshot-1.jpg)

### 2. View and Edit Customer(Lead) Information ###
![View and Edit Customer(Lead) Information](screenshot-2.jpg)

### 3. View Conversion Funnel Log for Each Customer(Lead) ###
![View Conversion Funnel Log for Each Customer(Lead)](screenshot-3.jpg)

### 4. Get Notified on Lead Conversions ###
![Get Notified on Lead Conversions](screenshot-4.jpg)


## Changelog ##
### 1.5.9 ###
* Better required field validation for checkboxes

### 1.5.8 ###
* Even more security updates! Security for the win!

### 1.5.7 ###
* Security Patch

### 1.5.6 ###
* Fix double lead notification email

### 1.5.5 ###
* Contact form 7 fix

### 1.5.4 ###
* Added form field exclusions to ignore sensitive data

### 1.5.2 ###
* See Changelog Here: https://github.com/inboundnow/leads/issues?q=is%3Aissue+is%3Aclosed+label%3Av1.5.2

### 1.5.1 ###
* Improved form email typo detection
* Improved Template Styles
* Fixed content wysiwyg scroll freezing bug

### 1.5.0 ###
* Added Lead API
* Added CSV exporting to Lead Management
* Moved language file out of shared folder
* Bug Fix: Email Systems
* Bug Fix: Lead notification email treats multiple selections correctly now.
* Add default email confirmation subject when empty.

### 1.4.6 ###
* Bug Fix: Lead notification emails are fixed.

### 1.4.5 ###
* Bug Fix: Renamed constant WPL_URLPATH to WPL_URLPATH to fix shared asset loading.

### 1.4.3 ###
* Bug Fix: Remove marketing automation button for non-admin members logged in
* 100% support for the fr_FR

### 1.4.2 ###
* Bug Fix: Check all required fields

### 1.4.1 ###
* Bug Fix: Inbound form's email response fix for email body.
* Bug Fix: Admin bar marketing button showing for non admin logged in users.
* Added: Inbound forms now have a 'Country' dropdown.
* Added: These inbound form field elements now accept placeholders and/or html in labels: textarea, dropdown, checkbox.
* Added: Wrap Inbound form fields with pre-defined classes.
* Added: Create lead lists from within form creation tool
* Added: Filter form submissions through Akismet
* Improvement: Refactored serveral modules to be written in Class standard.

### 1.3.9 ###
* Fix to insert marketing shortcode popup

### 1.3.8 ###
* Overwrite core wordpress email template with customizable email templates.
* Lead notification email templates can now be customized.
* Improve analytics

### 1.3.7 ###
* Temporary fix for shortcodes disappearing from wordpress 3.8 to 3.9
* Performance improvements on analytics and lead tracking

### 1.3.6 ###
* Misc bug fixes

### 1.3.5 ###
* fixed field mapping bug
* Added better compability for js conflicts
* Prepping for automation

### 1.3.4 ###
* Improved form compatibilty with contact form 7, gravity forms, and ninja forms
* Now tracking blog comments. View the new comments tab in the lead activity profile!
* Now tracking searches made by leads. View the new search tab in the lead activity profile!
* Numerous bug files and code improvements

### 1.3.3 ###
* Updated Bulk lead management tool
* Added Google Analytics Custom Event Tracking for form submissions
* Added Ability: automatically sort leads into lists on form completions
* Added Ability: Send lead notification emails to multiple people. Use comma separated values
* Added New Lead Tags option for additional ways to sort and categorize/tag leads
* Updated main docs.inboundnow.com site. Check it out!

### 1.3.2 ###
* GPL update with js

### 1.3.1 ###
* New Feature: Bulk Lead management
* Added tags to lead profiles for improved management/categorization
* Added new compatibility options to fix third party plugin conflicts!
* Added new debugging javascript debugging tools for users
* Fixed Email Sending Error on forms
* Improved support for master license keys

### 1.3.0 ###
* Added New HTML Lead Email Template with clickable links for faster lead management
* Added Button Shortcodes!
* Added HTML field option to form tool
* Added Divider Option to Form tool
* Added multi column support to icon list shortcode
* Added Font Awesome Icons option to Inbound Form Submit buttons
* Added Social Sharing Shortcode

### 1.2.5 ###
* Bug fix - missing trackingObj

### 1.2.4 ###
* Added feature request form to all plugin admin pages. Submit your feature requests today! =)

### 1.2.3 ###
* Bug fixes for form creation issues
* Bug fixes for safari page tracking not firing
* Added quick menu to WP admin bar for quicker marketing!

### 1.2.2 ###
* Updated: Styles to WordPress 3.8
* Updated: Shortcode fixes


### 1.2.1 ###
* Added: Time on time per page view
* Updated: Conversion paths into session history
* Updated: Form tool.

### 1.2.0 ###

* Added: Added email confirmation support to Inbound Forms tool
* Added: New Shortcodes Fancy List and Column shortcodes
* Added: Field Mapping for other langauges for Inbound Form tool

### 1.1.1 ###

* Added: Added InboundNow form creation and management system (beta)
* Added: Support for InboundNow cross plugin extensions
* Added: 'header' setting component to global settings.
* Added: bulk add lead to list.
* Improvement: Improved data management for global settings, metaboxes, and extensions.
* fix: fixed issue with CSV bulk lead exporting.

### 1.0.0.5 ###
* Fix issue with lead's first conversion not inserting into database correctly.

### 1.0.0.2 ###
* Improved list view layout
* Fixed some JS errors

### 1.0.0.1 ###

Released